/* netbox.h
 *
 *   SAPF kernel module
 *
 *   header file for an internal API for access to layer 2+3 service points
 *
 * Copyright (C) 2001-2003 <christian.tschudin@unibas.ch>
 *
 * This file is distributed under the terms of the GNU general Public
 * License (GPL), see the file COPYING
 *
 *   2003-11-20 added netbox_hasDGF(), removed netbox_arpannounce()
 *   2003-01-xx commented out addL3if(), not suitable for kernel version.
 */

#ifndef _NETBOX_H
#define _NETBOX_H

#ifndef NS_PORT

  struct netbox_timer_s {
        void (*fct)(void *data);
        void *data;
	unsigned long expires;
        struct netbox_timer_s *next;
  };
  typedef struct netbox_timer_s netbox_timer_t;

#else

  class NETBOXTimer;
#define  netbox_timer_t NETBOXTimer

#endif



#endif
