/* netbox_decl.h
 *
 *   SAPF kernel module
 *
 *   header file for an internal API for access to layer 2+3 service points
 *
 * Copyright (C) 2001-2004 <christian.tschudin@unibas.ch>
 *
 * This file is distributed under the terms of the GNU general Public
 * License (GPL), see the file COPYING
 *
 *   2003-11-20 added netbox_hasDGF(), removed netbox_arpannounce()
 *   2003-01-xx commented out addL3if(), not suitable for kernel version.
 */

#ifndef _NETBOX_DECL_H
#define _NETBOX_DECL_H

//NETBOX_DECLARATIONS
NS_EXTERN int  netbox_init(void);
NS_EXTERN void netbox_fini(void);

NS_EXTERN int netbox_addL2if(int ifnr, int handle);
NS_EXTERN int netbox_dropL2if(int ifnr);
NS_EXTERN int netbox_getL2addr(int ifnr, struct sockaddr *sa);

NS_EXTERN int netbox_getL3addr(struct lunartarget_s *name, struct net_device *dev, char fam);
NS_EXTERN int netbox_getL3bc_addr(struct in_addr *name, struct net_device *dev);

NS_EXTERN int netbox_l2send(int ifnr, struct sockaddr *dest, sapfsel_t sel,
			 void *data, int len);
NS_EXTERN int netbox_l3deliver(int ifnr, void *data, int len);
NS_EXTERN void netbox_nat(sapfpkt *pkt, void *aux);
NS_EXTERN int netbox_neigh_map(struct net_device *dev,
			       struct lunartarget_s *target, char *eth);
NS_EXTERN int netbox_neigh_unmap(struct net_device *dev,
				 struct lunartarget_s *target);
NS_EXTERN void netbox_newtimer(netbox_timer_t *t,
			       void (NS_CLASS *fct)(void *),
			       void *data, unsigned long delta_usec);
NS_EXTERN void netbox_deltimer(netbox_timer_t *t);

NS_EXTERN int  netbox_hasDGW(void);

//END OF NETBOX_DECLARATIONS


#endif //_NETBOX_DECL_H
