/* platform_ns2.h
 *
 *   LUNAR - Lightweight Underlay Network Ad hoc Routing
 *
 *   header file with platform specific definitions
 *
 * Copyright (C) 2004 <evgeny.osipov@unibas.ch> and
 *                    <christian.tschudin@unibas.ch>
 *
 * This file is distributed under the terms of the GNU general Public
 * License (GPL), see the file COPYING
 */

#ifndef PLATFORM_NS2_H
#define PLATFORM_NS2_H

//General defs
#define NS_CLASS  SELNET::
#define NS_CLASS_addr &SELNET::
#define NS_CLASS_Instance_PTR selnet_->*
#define _VOID_VOID_ NS_CLASS_addr
#define SAPF_CLASS SAPF::
#define SAPF_Instance sapf_->

#define NS_STATIC
// change to NS_EXTERN
#define NS_EXTERN 


#define NETBOX_CLASS NETBOX::
#define NETBOX_Instance netbox_->
#define PACKET_TYPE (Packet*)
#define printk printf

//redefinition of functions for memory de-/allocation 
#define kfree(x) free(x) 
#define kfree_skb(s) (Packet::free(s))//to free a packet
#define kmalloc(x,y) malloc(x)


#define uint8_t u_int8_t
#define uint16_t u_int16_t

struct net_device {
  int ifindex;
}; 

//redefinition of net_device_stat we don't include the appropriate library but need this structure
struct net_device_stats {
  int tx_packets;
  int tx_bytes;
  int rx_packets;
  int rx_bytes;
};



#define GFP_KERNEL 0 //check this
//#define forwarding "yes"

#define SELNET_HDR_LEN 8

#define UP_MODULE_USE()   // check this DbgPrint("MOD_INC_USE_COUNT")
#define DOWN_MODULE_USE() // check this DbgPrint("MOD_INC_USE_COUNT")

//typedef unsigned long long u_int64_t
//#define debuglevel 0
#define DEBUG(l,stmt)		{ if ((l) <= debuglevel) { \
	printf("#%-2d %f ", My_IP, Scheduler::instance().clock()); \
	stmt; \
}}
#define DEBUG_TARGET(l,str,tgt)	do {if ((l) <= debuglevel) { \
	printf("#%-2d %f ", My_IP, Scheduler::instance().clock()); \
	debug_target(str,tgt);\
} } while (0)

#define const64u(x) (x##ULL)
#define const64(x) (x##LL)


typedef unsigned long long __u64;
//no conversion to host or network format only host hormat
unsigned long long __fswab64(__u64 x) {
	return
                (((__u64)x & (__u64)0x00000000000000ffULL) << 56) |
                (((__u64)x & (__u64)0x000000000000ff00ULL) << 40) |
                (((__u64)x & (__u64)0x0000000000ff0000ULL) << 24) |
                (((__u64)x & (__u64)0x00000000ff000000ULL) <<  8) |
                (((__u64)x & (__u64)0x000000ff00000000ULL) >>  8) |
                (((__u64)x & (__u64)0x0000ff0000000000ULL) >> 24) |
                (((__u64)x & (__u64)0x00ff000000000000ULL) >> 40) |
                (((__u64)x & (__u64)0xff00000000000000ULL) >> 56) ;
}



#define htonsel(s) __fswab64(s)
#define ntohsel(s) __fswab64(s)

#define arm_timer(tp,ams) do{(tp)->expires=(ams);add_timer(tp);}while(0)
#define cancel_timer(tp)  del_timer(tp)


/*CLARIFY WHAT TO DO WITH THESE FUNCs*/
#define jiffies 0.0// we do not use jiffies*/
#define HZ 1.0 //Timer for sapf_gc will be activated in 1 second .

#define ETH_ALEN sizeof(int)

#endif // PLATFORM_NS2_H
