/* xrp_decl.h
 *
 *   SAPF kernel module
 *
 *   header file for declaration of methods and variables for
 *   XRP (extensible resolution protocol)
 *
 * Copyright (C) 2003 <christian.tschudin@unibas.ch>
 *
 * This file is distributed under the terms of the GNU general Public
 * License (GPL), see the file COPYING
 *
 */

#ifndef XRP_DECL_H
#define XRP_DECL_H

//XRP_DECLARATIONS

NS_EXTERN int xrp_param_len[XRP_CTYPE__COUNT];

NS_EXTERN void* xrp_locate(void *buf, int len, int parclass);
NS_EXTERN int   xrp_fill_hdr(void *buf, int cmd, int ttl);
NS_EXTERN int   xrp_fill_sel(void *buf, int parclass, sapfsel_t sel);
NS_EXTERN int   xrp_fill_sel_eth(void *buf, int parclass, sapfsel_t sel, unsigned char *eth);
NS_EXTERN int   xrp_fill_ipv4(void *buf, int parclass, struct in_addr ip);
NS_EXTERN int   xrp_fill_name(void *buf, int parclass, char *s);
NS_EXTERN int   xrp_fill_hit128(void *buf, int parclass, hit_t *hit);
NS_EXTERN int   xrp_fill_eom(void *buf);

#ifdef LUNAR_HAS_IPV6
NS_EXTERN int   xrp_fill_ipv6(void *buf, int parclass, struct in6_addr *ip6);
#endif

//END OF XRP_DECLARATIONS

#endif // XRP_DECL_H
