#!/bin/bash

WLAN=eth2
WLANMAC=00:60:1D:F7:29:94
UMLMAC=fe:fd:c0:a8:33:63
LDIR=/home/zaurus/uml
TDIR=/home/zaurus/bin
USER=zaurus

case "$1" in
    start)
	iwconfig $WLAN mode ad-hoc essid lunar channel 3
	ifconfig $WLAN 0.0.0.0 promisc up
#	ifconfig $WLAN 192.168.52.129 promisc up

	brctl addbr uml-bridge
	brctl setfd uml-bridge 0
	brctl sethello uml-bridge 0
	brctl stp uml-bridge off
	ifconfig uml-bridge 192.168.0.100 netmask 255.255.255.0 up

	brctl addif uml-bridge $WLAN

	$TDIR/tunctl -u $USER -t uml-conn0
	ifconfig uml-conn0 0.0.0.0 promisc up

	brctl addif uml-bridge uml-conn0

	ebtables -t nat -A POSTROUTING -o $WLAN -j snat --to-source $WLANMAC
	ebtables -t nat -A PREROUTING -i $WLAN -j dnat --to-destination $UMLMAC
	;;

    linux)
	$LDIR/linux mem=48M ubd0=$LDIR/root_fs eth0=tuntap,uml-conn0
	;;

    stop)
	ebtables -t nat -F

	ifconfig uml-bridge down

	brctl delif uml-bridge $WLAN
	brctl delif uml-bridge uml-conn0
	brctl delbr uml-bridge

	$TDIR/tunctl -d uml-conn0
	;;

    *)
	echo "Usage: vlunar { start | linux | stop }"
	echo "   (call 'start' and 'stop' as root!)"
	exit 1
	;;

esac

# eof
